Skip to content
GitLab
Explore
Sign in
Register
Primary navigation
Search or go to…
Project
H
hgit
Manage
Activity
Members
Labels
Plan
Issues
Issue boards
Milestones
Wiki
Code
Merge requests
Repository
Branches
Commits
Tags
Repository graph
Compare revisions
Snippets
Build
Pipelines
Jobs
Pipeline schedules
Artifacts
Deploy
Releases
Package Registry
Container Registry
Model registry
Operate
Environments
Terraform modules
Monitor
Incidents
Analyze
Value stream analytics
Contributor analytics
CI/CD analytics
Repository analytics
Model experiments
Help
Help
Support
GitLab documentation
Compare GitLab plans
Community forum
Contribute to GitLab
Provide feedback
Keyboard shortcuts
?
Snippets
Groups
Projects
Show more breadcrumbs
Eduardo Trujillo
hgit
Commits
b560c145
Commit
b560c145
authored
8 years ago
by
Vincent Hanquez
Browse files
Options
Downloads
Patches
Plain Diff
update .travis
parent
7237dddb
No related branches found
Branches containing commit
No related tags found
Tags containing commit
No related merge requests found
Changes
1
Hide whitespace changes
Inline
Side-by-side
Showing
1 changed file
.travis.yml
+166
-27
166 additions, 27 deletions
.travis.yml
with
166 additions
and
27 deletions
.travis.yml
+
166
−
27
View file @
b560c145
env
:
-
CABALVER=1.16 GHCVER=7.4.2
-
CABALVER=1.18 GHCVER=7.6.3
-
CABALVER=1.18 GHCVER=7.8.3
-
CABALVER=1.22 GHCVER=7.10.1
-
CABALVER=head GHCVER=head
# Use new container infrastructure to enable caching
sudo
:
false
# Choose a lightweight base image; we provide our own build tools.
language
:
c
# Caching so the next build will be fast too.
cache
:
directories
:
-
$HOME/.ghc
-
$HOME/.cabal
-
$HOME/.stack
# The different configurations we want to test. We have BUILD=cabal which uses
# cabal-install, and BUILD=stack which uses Stack. More documentation on each
# of those below.
#
# We set the compiler values here to tell Travis to use a different
# cache file per set of arguments.
#
# If you need to have different apt packages for each combination in the
# matrix, you can use a line such as:
# addons: {apt: {packages: [libfcgi-dev,libgmp-dev]}}
matrix
:
include
:
# We grab the appropriate GHC and cabal-install versions from hvr's PPA. See:
# https://github.com/hvr/multi-ghc-travis
#- env: BUILD=cabal GHCVER=7.0.4 CABALVER=1.16 HAPPYVER=1.19.5 ALEXVER=3.1.7
# compiler: ": #GHC 7.0.4"
# addons: {apt: {packages: [cabal-install-1.16,ghc-7.0.4,happy-1.19.5,alex-3.1.7], sources: [hvr-ghc]}}
#- env: BUILD=cabal GHCVER=7.2.2 CABALVER=1.16 HAPPYVER=1.19.5 ALEXVER=3.1.7
# compiler: ": #GHC 7.2.2"
# addons: {apt: {packages: [cabal-install-1.16,ghc-7.2.2,happy-1.19.5,alex-3.1.7], sources: [hvr-ghc]}}
-
env
:
BUILD=cabal GHCVER=7.4.2 CABALVER=1.16 HAPPYVER=1.19.5 ALEXVER=3.1.7
compiler
:
"
:
#GHC
7.4.2"
addons
:
{
apt
:
{
packages
:
[
cabal-install-1.16
,
ghc-7.4.2
,
happy-1.19.5
,
alex-3.1.7
],
sources
:
[
hvr-ghc
]}}
-
env
:
BUILD=cabal GHCVER=7.6.3 CABALVER=1.16 HAPPYVER=1.19.5 ALEXVER=3.1.7
compiler
:
"
:
#GHC
7.6.3"
addons
:
{
apt
:
{
packages
:
[
cabal-install-1.16
,
ghc-7.6.3
,
happy-1.19.5
,
alex-3.1.7
],
sources
:
[
hvr-ghc
]}}
-
env
:
BUILD=cabal GHCVER=7.8.4 CABALVER=1.18 HAPPYVER=1.19.5 ALEXVER=3.1.7
compiler
:
"
:
#GHC
7.8.4"
addons
:
{
apt
:
{
packages
:
[
cabal-install-1.18
,
ghc-7.8.4
,
happy-1.19.5
,
alex-3.1.7
],
sources
:
[
hvr-ghc
]}}
-
env
:
BUILD=cabal GHCVER=7.10.3 CABALVER=1.22 HAPPYVER=1.19.5 ALEXVER=3.1.7
compiler
:
"
:
#GHC
7.10.3"
addons
:
{
apt
:
{
packages
:
[
cabal-install-1.22
,
ghc-7.10.3
,
happy-1.19.5
,
alex-3.1.7
],
sources
:
[
hvr-ghc
]}}
-
env
:
BUILD=cabal GHCVER=8.0.1 CABALVER=1.22 HAPPYVER=1.19.5 ALEXVER=3.1.7
compiler
:
"
:
#GHC
8.0.1"
addons
:
{
apt
:
{
packages
:
[
cabal-install-1.22
,
ghc-8.0.1
,
happy-1.19.5
,
alex-3.1.7
],
sources
:
[
hvr-ghc
]}}
# Build with the newest GHC and cabal-install. This is an accepted failure,
# see below.
-
env
:
BUILD=cabal GHCVER=head CABALVER=head HAPPYVER=1.19.5 ALEXVER=3.1.7
compiler
:
"
:
#GHC
HEAD"
addons
:
{
apt
:
{
packages
:
[
cabal-install-head
,
ghc-head
,
happy-1.19.5
,
alex-3.1.7
],
sources
:
[
hvr-ghc
]}}
# The Stack builds. We can pass in arbitrary Stack arguments via the ARGS
# variable, such as using --stack-yaml to point to a different file.
#- env: BUILD=stack ARGS=""
# compiler: ": #stack default"
# addons: {apt: {packages: [ghc-7.10.3], sources: [hvr-ghc]}}
#- env: BUILD=stack ARGS="--resolver lts-2"
# compiler: ": #stack 7.8.4"
# addons: {apt: {packages: [ghc-7.8.4], sources: [hvr-ghc]}}
#- env: BUILD=stack ARGS="--resolver lts-3"
# compiler: ": #stack 7.10.2"
# addons: {apt: {packages: [ghc-7.10.2], sources: [hvr-ghc]}}
#- env: BUILD=stack ARGS="--resolver lts-5"
# compiler: ": #stack 7.10.3"
# addons: {apt: {packages: [ghc-7.10.3], sources: [hvr-ghc]}}
# Nightly builds are allowed to fail
#- env: BUILD=stack ARGS="--resolver nightly"
# compiler: ": #stack nightly"
# addons: {apt: {packages: [libgmp,libgmp-dev]}}
# Build on OS X in addition to Linux
#- env: BUILD=stack ARGS=""
# compiler: ": #stack default osx"
# os: osx
#- env: BUILD=stack ARGS="--resolver lts-2"
# compiler: ": #stack 7.8.4 osx"
# os: osx
#- env: BUILD=stack ARGS="--resolver lts-3"
# compiler: ": #stack 7.10.2 osx"
# os: osx
#- env: BUILD=stack ARGS="--resolver lts-5"
# compiler: ": #stack 7.10.3 osx"
# os: osx
#- env: BUILD=stack ARGS="--resolver nightly"
# compiler: ": #stack nightly osx"
# os: osx
allow_failures
:
-
env
:
GHCVER=head
-
env
:
BUILD=cabal GHCVER=head CABALVER=head HAPPYVER=1.19.5 ALEXVER=3.1.7
-
env
:
BUILD=stack ARGS="--resolver nightly"
before_install
:
-
travis_retry sudo add-apt-repository -y ppa:hvr/ghc
-
travis_retry sudo apt-get update
-
travis_retry sudo apt-get install cabal-install-$CABALVER ghc-$GHCVER
# see note about happy/alex
-
export PATH=/opt/ghc/$GHCVER/bin:/opt/cabal/$CABALVER/bin:$PATH
# Using compiler above sets CC to an invalid value, so unset it
-
unset CC
# We want to always allow newer versions of packages when building on GHC HEAD
-
CABALARGS=""
-
if [ "x$GHCVER" = "xhead" ]; then CABALARGS=--allow-newer; fi
# Download and unpack the stack executable
-
export PATH=/opt/ghc/$GHCVER/bin:/opt/cabal/$CABALVER/bin:$HOME/.local/bin:/opt/alex/$ALEXVER/bin:/opt/happy/$HAPPYVER/bin:$HOME/.cabal/bin:$PATH
-
mkdir -p ~/.local/bin
-
|
if [ `uname` = "Darwin" ]
then
travis_retry curl --insecure -L https://www.stackage.org/stack/osx-x86_64 | tar xz --strip-components=1 --include '*/stack' -C ~/.local/bin
else
travis_retry curl -L https://www.stackage.org/stack/linux-x86_64 | tar xz --wildcards --strip-components=1 -C ~/.local/bin '*/stack'
fi
# Use the more reliable S3 mirror of Hackage
mkdir -p $HOME/.cabal
echo 'remote-repo: hackage.haskell.org:http://hackage.fpcomplete.com/' > $HOME/.cabal/config
echo 'remote-repo-cache: $HOME/.cabal/packages' >> $HOME/.cabal/config
if [ "$CABALVER" != "1.16" ]
then
echo 'jobs: $ncpus' >> $HOME/.cabal/config
fi
# Get the list of packages from the stack.yaml file
-
PACKAGES=$(stack --install-ghc query locals | grep '^ *path' | sed 's@^ *path:@@')
install
:
-
cabal --version
-
echo "$(ghc --version) [$(ghc --print-project-git-commit-id 2> /dev/null || echo '?')]"
-
travis_retry cabal update
-
cabal install --only-dependencies --enable-tests
-
echo "$(ghc --version) [$(ghc --print-project-git-commit-id 2> /dev/null || echo '?')]"
-
if [ -f configure.ac ]; then autoreconf -i; fi
-
|
set -ex
case "$BUILD" in
stack)
stack --no-terminal --install-ghc $ARGS test --bench --only-dependencies
;;
cabal)
cabal --version
travis_retry cabal update
cabal install --only-dependencies --enable-tests --enable-benchmarks --force-reinstalls --ghc-options=-O0 --reorder-goals --max-backjumps=-1 $CABALARGS $PACKAGES
;;
esac
set +ex
script
:
-
cabal configure --enable-tests -v2
-
cabal build
-
cabal test
-
cabal sdist
-
export SRC_TGZ=$(cabal info . | awk '{print $2 ".tar.gz";exit}') ;
cd dist/;
if [ -f "$SRC_TGZ" ]; then
cabal install --force-reinstalls "$SRC_TGZ";
else
echo "expected '$SRC_TGZ' not found";
exit 1;
fi
-
|
set -ex
case "$BUILD" in
stack)
stack --no-terminal $ARGS test --bench --no-run-benchmarks --haddock --no-haddock-deps
;;
cabal)
cabal install --enable-tests --enable-benchmarks --force-reinstalls --ghc-options=-O0 --reorder-goals --max-backjumps=-1 $CABALARGS $PACKAGES
ORIGDIR=$(pwd)
for dir in $PACKAGES
do
cd $dir
cabal check || [ "$CABALVER" == "1.16" ]
cabal sdist
SRC_TGZ=$(cabal info . | awk '{print $2;exit}').tar.gz && \
(cd dist && cabal install --force-reinstalls "$SRC_TGZ")
cd $ORIGDIR
done
;;
esac
set +ex
This diff is collapsed.
Click to expand it.
Preview
0%
Loading
Try again
or
attach a new file
.
Cancel
You are about to add
0
people
to the discussion. Proceed with caution.
Finish editing this message first!
Save comment
Cancel
Please
register
or
sign in
to comment